package com.clustercontrol.cloud.azure.factory;

import java.util.HashMap;
import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

import com.microsoft.windowsazure.services.blob.implementation.MetadataAdapter;

@XmlRootElement(name = "EnumerationResults")
public class ListBlobsResult {
	private String prefix;
	private String marker;
	private int maxResults;
	private String delimiter;
	private List<Blob> blobs;
    private String nextMarker;
    
    @XmlElementWrapper(name = "Blobs")
    @XmlElement(name = "Blob")
    public List<Blob> getBlobs() {
        return this.blobs;
    }
    
    public void setBlobs(List<Blob> blobs){
    	this.blobs = blobs;
    }
    
    @XmlElement(name = "Prefix")
    public String getPrefix() {
        return this.prefix;
    }
    
    public void setPrefix(String prefix){
    	this.prefix = prefix;
    }
    
    @XmlElement(name = "Delimiter")
    public String getDelimiter() {
        return this.delimiter;
    }
    
    public void setDelimiter(String delimiter){
    	this.delimiter = delimiter;
    }
    
    @XmlElement(name = "MaxResults")
    public int getMaxResults() {
        return this.maxResults;
    }
    
    public void setMaxResults(int maxResults){
    	this.maxResults = maxResults;
    }
    
    @XmlElement(name = "Marker")
    public String getMarker() {
        return this.marker;
    }
    
    public void setMarker(String marker){
    	this.marker = marker;
    }
    
    @XmlElement(name = "NextMarker")
    public String getNextMarker() {
        return nextMarker;
    }
    
    public void setNextMarker(String nextMarker) {
        this.nextMarker = nextMarker;
    }
    
    public static class Blob {
        private String name;
        private String snapshot;
        private BlobProperties properties;
        private HashMap<String, String> metadata = new HashMap<String, String>();

        @XmlElement(name = "Name")
        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }
        
        @XmlElement(name = "Snapshot")
        public String getSnapshot() {
            return snapshot;
        }

        public void setSnapshot(String snapshot) {
            this.snapshot = snapshot;
        }

        @XmlElement(name = "Properties")
        public BlobProperties getProperties() {
            return properties;
        }

        public void setProperties(BlobProperties properties) {
            this.properties = properties;
        }

        @XmlElement(name = "Metadata")
        @XmlJavaTypeAdapter(MetadataAdapter.class)
        public HashMap<String, String> getMetadata() {
            return metadata;
        }

        public void setMetadata(HashMap<String, String> metadata) {
            this.metadata = metadata;
        }
    }
}
